{- Language 0: floating-point airthmetic -}

module Demo0 where

data Exp
  = Con Float
  | Add Exp Exp
  | Mul Exp Exp
  | Pow Exp Exp

c = Con 3 `Mul` (Con 10 `Pow` Con 8)

{- Evaluate an Exp -}
eval :: Exp -> Float
eval (Con k)   = k
eval (Add e1 e2) = eval e1 + eval e2
eval (Mul e1 e2) = eval e1 * eval e2
-- eval (Pow e1 e2) = eval e1 ^ eval e2 -- saved by GHC's type-checker!
eval (Pow e1 e2) = eval e1 ** eval e2

{- ✅ eval c -}

{- 🏋️ reimplement eval using an algebra -}
